#ifndef AVATAR_H
#define AVATAR_H

typedef struct Avatar
{
	/* The ID of the avatar */
	unsigned short int id;

	/* X and Y coordinates on the game plane */
	float x, y;

	/* Rotational velocity */
	float r;

	/* X and Y velocities */
	float vx, vy;

	/* Score for this player */
	unsigned int score;

	/* Current shape of the avatar */
	enum shapes { circle = 1, triangle, pentagon, semicircle } shape;

	/* If the shape was popped last iteration */
	bool popped;
} avatar;

typedef struct AvatarList
{
	/* Array of pointers to avatars */
	avatar** as;

	/* Which avatar -we- are! */
	unsigned char us;

	/* How many there are */
	unsigned short int cur;

	/* The msx we can hold */
	unsigned short int max;
} avatarList;

#endif /* AVATAR_H */
