#include <SDL/SDL_net.h>

#ifndef CLIENTS_H
#define CLIENTS_H

typedef struct Client
{
	/* The IP address of the client */
	char ip[16];

	/* A pointer to their (server) thread */
	SDL_Thread* thread;

	/* Their socket */
	TCPsocket sock;

	/* Non-zero and set to a shape if they are trying to change shapes */
	unsigned short int shapeChange;

	/* True if they're holding down the left arrow */
	bool leftDown;

	/* True if they're holding down the right arrow */
	bool rightDown;
} client;

typedef struct ClientList
{
	/* Array of pointers to clients */
	client** cs;

	/* How many there are */
	unsigned short int cur;

	/* The max we can hold */
	unsigned short int max;
} clientList;

#endif /* CLIENTS_H */
