#include "config.h"

kvlist* readConfigFile(const char* restrict configname)
{
	unsigned short int i;
	FILE* fp;
	char* buf;
	char *key, *val;
	keyval* kv;
	kvlist* ret;

	fp = fopen(configname, "rb");
	if(!fp)
	{
		fprintf(stderr, "readConfigFile:\tCould not find config file (%s).\n", configname);
		fprintf(stdout, "readConfigFile:\tContinuing without a configuration file.\n");
		return NULL;
	}

	assert(fp != NULL);

	ret = kvlistCreate();

	while(fgets((buf = scalloc(80, sizeof(char))), 80, fp))
	{
		/* Line is a comment, continue */
		if(!isalpha(*buf))
		{
			sfree(buf);
			continue;
		}
		val = NULL;
		key = buf;
		for(i = 0; i < 80; i++)
		{
			if(buf[i] == '=')
			{
				buf[i] = '\0';
				val = buf + i + 1;
			}
			else if(buf[i] == '\n')
			{
				/* Don't include newline */
				buf[i] = '\0';
				break;
			}
		}
		assert(val != NULL);
		kv = kvalCreate(key, val);
		kvlistPush(ret, kv);
		sfree(buf);
	}
	sfree(buf);
	fclose(fp);

	return ret;
}
