#include "input.h"

int input(void* data)
{
	bool* restrict done = ((bool**)data)[0];
	const avatarList* restrict avatars = ((avatarList**)data)[1];
	const TCPsocket sock = *((TCPsocket**)data)[2];

	/* Event we got to handle */
	SDL_Event event;

	assert(done != NULL);
	assert(avatars != NULL);
	assert(sock != NULL);

	/* While we're not done */
	while(!*done)
	{
		while(SDL_WaitEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					*done = true;
					break;
				case SDL_KEYDOWN:
					switch(event.key.keysym.sym)
					{
						case SDLK_LEFT:
							if(ssend(sock, "LD", 2) != 2)
								fprintf(stderr, "IN:\tCould not send LD event to server.\n"); // TODO: handle this?
							break;
						case SDLK_RIGHT:
							if(ssend(sock, "RD", 2) != 2)
								fprintf(stderr, "IN:\tCould not send RD event to server.\n"); // TODO: handle this?
							break;
						default:
							break;
					}
					break;
				case SDL_KEYUP:
					switch(event.key.keysym.sym)
					{
						case SDLK_ESCAPE:
							*done = true;
							break;
						case SDLK_LEFT:
							if(ssend(sock, "LU", 2) != 2)
								fprintf(stderr, "IN:\tCould not send LU event to server.\n"); // TODO: handle this?
							break;
						case SDLK_RIGHT:
							if(ssend(sock, "RU", 2) != 2)
								fprintf(stderr, "IN:\tCould not send RU event to server.\n"); // TODO: handle this?
							break;
						case SDLK_1:
							if(ssend(sock, "S1", 2) != 2)
								fprintf(stderr, "IN:\tCould not send S1 event to server.\n"); // TODO: handle this?
							break;
						case SDLK_2:
							if(ssend(sock, "S2", 2) != 2)
								fprintf(stderr, "IN:\tCould not send S2 event to server.\n"); // TODO: handle this?
							break;
						case SDLK_3:
							if(ssend(sock, "S3", 2) != 2)
								fprintf(stderr, "IN:\tCould not send S3 event to server.\n"); // TODO: handle this?
							break;
						case SDLK_4:
							if(ssend(sock, "S4", 2) != 2)
								fprintf(stderr, "IN:\tCould not send S4 event to server.\n"); // TODO: handle this?
							break;
						default:
							break;
					}
					break;
				default:
					break;
			}
			if(*done)
				break;
		}
	}

	return SUCCESS;
}
