/* OpenGL stuff */
#include <GL/gl.h>
#include <GL/glu.h>

/* Sys stuff */
#include <stdlib.h>

/* File I/O */
#include <stdio.h>

/* Asserts are good */
#include <assert.h>

/* s*alloc, sfree */
#include "shared.h"

/* shrchr, strcpy, etc. */
#include "string.h"

#ifndef MAP_H
#define MAP_H

typedef struct Map
{
	/* The starting location by pixel */
	unsigned int startx, starty;

	/* The size of each tile */
	unsigned short int tilex, tiley;

	/* The size of the map in tiles */
	unsigned short int maptx, mapty;

	/* The list of filenames, aka tiles */
	char*** tiles;
} map;

typedef struct mapTile
{
	/* The filename of the tile */
	char filename[80];

	/* The OpenGL texture */
	GLuint tex;
} maptile;


map* loadMap(const char* restrict filename) __attribute__((nonnull));

void freeMap(map* restrict m) __attribute__((nonnull));

#endif /* MAP_H */
