#include <stdlib.h>
#include <SDL/SDL_net.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include "shared.h"

#include "stdio.h"

#ifndef NETWORKING_H
#define NETWORKING_H

/* Main return codes */
#define SUCCESS 0
#define BADARGS 1
#define SOCKFAIL 10
#define HOSTERR 20
#define SOCKERR 21
#define REMOTEHOSTERR 22

inline void sclose(TCPsocket sock);

inline ssize_t ssend(TCPsocket sock, const void* restrict data, size_t length) __attribute__((nonnull));

inline ssize_t srecv(TCPsocket sock, void* restrict buffer, size_t length) __attribute__((nonnull));

TCPsocket makeServerSocket(const unsigned short int port);

TCPsocket acceptConnection(TCPsocket listen, const bool* restrict done) __attribute__((nonnull));

TCPsocket socketConnect(const char* restrict server, const unsigned short int port) __attribute__((nonnull));

#endif /* NETWORKING_H */
