#include "serverphysics.h"

int serverphysics(void* data)
{
	const bool* restrict done = ((bool**)data)[0];
	avatarList* restrict avatars = ((avatarList**)data)[1];
	clientList* restrict clients = ((clientList**)data)[2];
	int tilew = *(((unsigned short int**)data)[3]);
	int maptw = *(((unsigned short int**)data)[4]);
	int tileh = *(((unsigned short int**)data)[5]);
	int mapth = *(((unsigned short int**)data)[6]);

	/* Size of a float */
	static const unsigned short int szav = sizeof(avatar);

	/* Iteration vars */
	unsigned short int i, j;

	/* Send counter, update clients when it reaches zero */
	unsigned short int sc = 10;

	/* The current client we're dealing with and their avatar */
	client* cc;
	avatar* ca;

	assert(done != NULL);
	assert(avatars != NULL);
	assert(clients != NULL);

	/* While we're not done */
	while(!*done)
	{
		/* If we need to update clients */
		if(sc == 0)
		{
			sc = 10;

			/* For each client */
			for(i = 0; i < clients->max; i++)
			{
				cc = clients->cs[i];
				if(cc == NULL)
				{
					continue;
				}

				/* Send them each avatar */
				for(j = 0; j < avatars->max; j++)
				{
					ca = avatars->as[j];
					if(ca == NULL)
					{
						continue;
					}
					fprintf(stderr, "Sending data to clients\n");

					if(ssend(cc->sock, ca, szav) != szav)
					{
						/* They disconnected without telling us */ // TODO: handle this
						fprintf(stderr, "Could not send avatar %i to client %i\n", j, i);
					}
				}
			}
		}

		/* For each client */
		for(i = 0; i < clients->max; i++)
		{
			cc = clients->cs[i];
			ca = avatars->as[i];
			if(cc)
			{
				if(cc->rightDown)
				{
					if(ca->vy < 1)
						ca->vy += .005;
					if(ca->vx < 1)
						ca->vx += .005;
				}
				if(cc->leftDown)
				{
					if(ca->vy > -1)
						ca->vy -= .005;
					if(ca->vx > -1)
						ca->vx -= .005;
				}
				ca->y += ca->vy;
				ca->x += ca->vx;
				if(ca->y <= 0)
				{
					ca->y = 1;
					ca->vy *= -1.0f;
				}
				if(ca->y >= tileh * mapth)
				{
					ca->y = tileh * mapth - 1;
					ca->vy *= -1.0f;
				}
                                if(ca->x <= 0)
                                {
                                        ca->x = 1;
                                        ca->vx *= -1.0f;
                                }
                                if(ca->x >= tilew * maptw)
                                {
                                        ca->x = tilew * maptw - 1;
                                        ca->vx *= -1.0f;
                                }
				if(ca->shape != cc->shapeChange)
					ca->shape = cc->shapeChange;
			}
		}

		--sc;
		usleep(1000);
	}

	return SUCCESS;
}
